<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__wdt" kind="group">
    <compoundname>group_wdt</compoundname>
    <title>WDT          (Watchdog Timer)</title>
    <innergroup refid="group__group__wdt__macros">Macros</innergroup>
    <innergroup refid="group__group__wdt__functions">Functions</innergroup>
    <briefdescription>
<para>The Watchdog timer (WDT) has a 16-bit free-running up-counter. </para>    </briefdescription>
    <detaileddescription>
<para>The functions and other declarations used in this driver are in cy_wdt.h. You can include cy_pdl.h to get access to all functions and declarations in the PDL.</para><para>The WDT can issue counter match interrupts, and a device reset if its interrupts are not handled. Use the Watchdog timer for two main purposes:</para><para>The <bold> First use case </bold> is recovering from a CPU or firmware failure. A timeout period is set up in the Watchdog timer, and if a timeout occurs, the device is reset (WRES). <linebreak />
 The <bold>Second use case</bold> is to generate periodic interrupts. It is strongly recommended not to use the WDT for periodic interrupt generation. However, if absolutely required, see information below.</para><para>A "reset cause" register exists, and the firmware should check this register at a start-up. An appropriate action can be taken if a WRES reset is detected.</para><para>The user's firmware periodically resets the timeout period (clears or "feeds" the watchdog) before a timeout occurs. If the firmware fails to do so, that is considered to be a CPU crash or a firmware failure, and the reason for a device reset. The WDT can generate an interrupt instead of a device reset. The Interrupt Service Routine (ISR) can handle the interrupt either as a periodic interrupt, or as an early indication of a firmware failure and respond accordingly. However, it is not recommended to use the WDT for periodic interrupt generation. The Multi-counter Watchdog Timers (MCWDT) can be used to generate periodic interrupts if such are presented in the device.</para><para><bold> Functional Description </bold></para><para>The WDT generates an interrupt when the count value in the counter equals the configured match value.</para><para>Note that the counter is not reset on a match. In such case the WDT reset period is: WDT_Reset_Period = ILO_Period * (2*2^(16-IgnoreBits) + MatchValue); When the counter reaches a match value, it generates an interrupt and then keeps counting up until it overflows and rolls back to zero and reaches the match value again, at which point another interrupt is generated.</para><para>To use a WDT to generate a periodic interrupt, the match value should be incremented in the ISR. As a result, the next WDT interrupt is generated when the counter reaches a new match value.</para><para>You can also reduce the entire WDT counter period by specifying the number of most significant bits that are ignored in the WDT counter. For example, if the <ref kindref="member" refid="group__group__wdt__functions_1gafad1413ff11cfb3e3e2b5d9854dc793e">Cy_WDT_SetIgnoreBits()</ref> function is called with parameter 3, the WDT counter becomes a 13-bit free-running up-counter.</para><para><bold> Power Modes </bold></para><para>WDT can operate in all possible low power modes. Operation during Hibernate mode is possible because the logic and high-voltage internal low oscillator (ILO) are supplied by the external high-voltage supply (Vddd). The WDT can be configured to wake the device from Hibernate mode.</para><para>In CPU Active mode, an interrupt request from the WDT is sent to the CPU. In CPU Sleep, CPU Deep Sleep mode, the CPU subsystem is powered down, so the interrupt request from the WDT is sent directly to the WakeUp Interrupt Controller (WIC) which will then wake up the CPU. The CPU then acknowledges the interrupt request and executes the ISR.</para><para><bold> Clock Source </bold></para><para>The WDT is clocked by the ILO. The WDT must be disabled before disabling the ILO. According to the device datasheet, the ILO accuracy is +/-30% over voltage and temperature. This means that the timeout period may vary by 30% from the configured value. Appropriate margins should be added while configuring WDT intervals to make sure that unwanted device resets do not occur on some devices.</para><para>Refer to the device datasheet for more information on the oscillator accuracy.</para><para><bold> Register Locking </bold></para><para>You can prevent accidental corruption of the WDT configuration by calling the <ref kindref="member" refid="group__group__wdt__functions_1gaec9bd8d1439389a46cdd2dcadc8e987d">Cy_WDT_Lock()</ref> function. When the WDT is locked, any writing to the WDT_*, CLK_ILO_CONFIG, CLK_SELECT.LFCLK_SEL, and CLK_TRIM_ILO_CTL registers is ignored. Call the <ref kindref="member" refid="group__group__wdt__functions_1ga51094ce9149f69553b6348eccbd89667">Cy_WDT_Unlock()</ref> function to allow registers modification, mentioned above.</para><para>Note that the WDT lock state is not retained during system Deep Sleep. After the wakeup from system Deep Sleep the WDT is locked.</para><para><bold> Clearing WDT </bold></para><para>The ILO clock is asynchronous to the SysClk. Therefore it generally takes three ILO cycles for WDT register changes to come into effect. It is important to remember that a WDT should be cleared at least four cycles (3 + 1 for sure) before a timeout occurs, especially when small match values / low-toggle bit numbers are used.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition warning"&gt;&lt;p class="admonition-title"&gt;warning&lt;/p&gt;&lt;p&gt;&lt;p&gt;It may happen that a WDT reset can be generated faster than a device start-up. To prevent this, calculate the start-up time and WDT reset time. The WDT reset time should be always greater than device start-up time.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><bold> Reset Detection </bold></para><para>Use the <ref kindref="member" refid="group__group__syslib__functions_1gac8aa61d2f8052886c676f4f592d1693d">Cy_SysLib_GetResetReason()</ref> function to detect whether the WDT has triggered a device reset.</para><para><bold> Interrupt Configuration </bold></para><para>If the WDT is configured to generate an interrupt, pending interrupts must be cleared within the ISR (otherwise, the interrupt will be generated continuously). A pending interrupt to the WDT block must be cleared by calling the <ref kindref="member" refid="group__group__wdt__functions_1ga727d9ae6fdba36809bf631985a3eb987">Cy_WDT_ClearInterrupt()</ref> function. The call to the function will clear the unhandled WDT interrupt counter.</para><para>Use the WDT ISR as a timer to trigger certain actions and to change a next WDT match value.</para><para>Ensure that the interrupts from the WDT are passed to the CPU to avoid unregistered interrupts. Unregistered WDT interrupts result in a continuous device reset. To avoid this, call <ref kindref="member" refid="group__group__wdt__functions_1ga38c69c98675d6024a7d73acb41b24399">Cy_WDT_UnmaskInterrupt()</ref>. After that, call the WDT API functions for interrupt handling/clearing.</para>
<para><heading level="1">Configuration Considerations</heading></para>
<para>To start the WDT, make sure that ILO is enabled. After the ILO is enabled, ensure that the WDT is unlocked and disabled by calling the <ref kindref="member" refid="group__group__wdt__functions_1ga51094ce9149f69553b6348eccbd89667">Cy_WDT_Unlock()</ref> and <ref kindref="member" refid="group__group__wdt__functions_1ga709f597d56e7f7fb6717d5ff671491fa">Cy_WDT_Disable()</ref> functions. Set the WDT match value by calling <ref kindref="member" refid="group__group__wdt__functions_1ga1e707a8236e6dcd90eede7e726a2648f">Cy_WDT_SetMatch()</ref> with the required match value. If needed, set the ignore bits for reducing the WDT counter period by calling <ref kindref="member" refid="group__group__wdt__functions_1gafad1413ff11cfb3e3e2b5d9854dc793e">Cy_WDT_SetIgnoreBits()</ref> function. After the WDT configuration is set, call <ref kindref="member" refid="group__group__wdt__functions_1ga82aec7e454d05d03dfd1d6fd5e573d5e">Cy_WDT_Enable()</ref>.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Enable a WDT if the power supply can produce sudden brownout events that may compromise the CPU functionality. This ensures that the system can recover after a brownout.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;When the WDT is used to protect against system crashes, the WDT interrupt should be cleared by a portion of the code that is not directly associated with the WDT interrupt. Otherwise, it is possible that the main firmware loop has crashed or is in an endless loop, but the WDT interrupt vector continues to operate and service the WDT. The user should:</verbatim><itemizedlist>
<listitem><para>Feed the watchdog by clearing the interrupt bit regularly in the main body of the firmware code.</para></listitem><listitem><para>Guarantee that the interrupt is cleared at least once every WDT period.</para></listitem><listitem><para>Use the WDT ISR only as a timer to trigger certain actions and to change the next match value.</para></listitem></itemizedlist>
</para>

<para><heading level="1">More Information</heading></para>
<para>For more information on the WDT peripheral, refer to the technical reference manual (TRM).</para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para>The WDT driver does not have any specific deviations.</para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;1.30 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated the following functions for the PSoC 64 devices: &lt;a href="group__group__wdt__functions.html#group__group__wdt__functions_1ga727d9ae6fdba36809bf631985a3eb987"&gt;Cy_WDT_ClearInterrupt()&lt;/a&gt;, &lt;a href="group__group__wdt__functions.html#group__group__wdt__functions_1gab6caa17bf5bcb0c365f60e602e653fed"&gt;Cy_WDT_MaskInterrupt()&lt;/a&gt;, and &lt;a href="group__group__wdt__functions.html#group__group__wdt__functions_1ga38c69c98675d6024a7d73acb41b24399"&gt;Cy_WDT_UnmaskInterrupt()&lt;/a&gt;. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added PSoC 64 device support.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Minor documentation updates. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.20 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added a new API function &lt;a href="group__group__wdt__functions.html#group__group__wdt__functions_1ga05f8bb5603ce46caf842bd0ad254f604"&gt;Cy_WDT_IsEnabled()&lt;/a&gt;  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Enhancement based on usability feedback.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.10.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added info that the WDT lock state is not retained during system Deep Sleep power mode.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation updates.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="4"&gt;&lt;p&gt;1.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Flattened the organization of the driver source code into the single source directory and the single include directory.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Driver library directory-structure simplification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Removed critical section usage in the following functions:&lt;ul&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__wdt__functions.html#group__group__wdt__functions_1gaac6f64babfb1855f9ba8aecccc19ecb4"&gt;Cy_WDT_Init()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__wdt__functions.html#group__group__wdt__functions_1gaec9bd8d1439389a46cdd2dcadc8e987d"&gt;Cy_WDT_Lock()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__wdt__functions.html#group__group__wdt__functions_1ga51094ce9149f69553b6348eccbd89667"&gt;Cy_WDT_Unlock()&lt;/a&gt;  &lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Driver functions simplification  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the &lt;a href="group__group__wdt__functions.html#group__group__wdt__functions_1gaac6f64babfb1855f9ba8aecccc19ecb4"&gt;Cy_WDT_Init()&lt;/a&gt;, &lt;a href="group__group__wdt__functions.html#group__group__wdt__functions_1ga82aec7e454d05d03dfd1d6fd5e573d5e"&gt;Cy_WDT_Enable()&lt;/a&gt; to clear WDT interrupt. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Corner case reliability improvements  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added register access layer. Use register access macros instead of direct register access using dereferenced pointers. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Makes register access device-independent, so that the PDL does not need to be recompiled for each supported part number.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0.2 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Minor documentation updates &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Corrected info about a reset generation  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;General documentation updates &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added info about periodic interrupt generation use case  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Initial version &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>